
import { BlueInfoBox, BulbBox, InfoBox, NoteBox, QaBox, WarnBox } from "../components/Boxes";
import { BFHMoreButton, ButtonOne } from "../components/Buttons";
import Collapsible from "../components/Collapsible";
import PieChart from "../components/Graph";
import H1, { H2, H3, Hhighlight, Hhopp, Hsmoke, Hspoiler, Hwave } from "../components/Headings";
import { LoremMedium, LoremShort } from "../components/Loremipsum";
import SimpleSlider from "../components/Slider";
import React from 'react';
import { Bar, Doughnut, PolarArea } from 'react-chartjs-2';
import { Chart as ChartJS, Tooltip, Legend, BarElement, CategoryScale, LinearScale, Title, RadialLinearScale } from 'chart.js';
import ProteinViewer from '../components/Fanzorviewer.tsx';
import { useNavigateTabs } from "../utils/navigation.ts";


ChartJS.register(
    CategoryScale,
    RadialLinearScale,
    LinearScale,
    BarElement,
    Title,
    Tooltip,
    Legend
  );
  
export function Example() {
  useTabNavigation();
    return (
      <>
      <div className="container">
            <h1>Protein Structure Viewer</h1>
            <ProteinViewer/>
          </div>
       
      <h1> Here you can see what we can use</h1>
      <h2>Collapisbles</h2>
      <div className="row">
        <div className="col">
            <details>
                <summary>Expand me</summary>
                <LoremMedium></LoremMedium>
            </details>
        </div>
        <div className="col">
            <Collapsible title="Title" id="collapsible"> <LoremMedium></LoremMedium></Collapsible>
        </div>
      </div>
    <h2>Boxes</h2>
      <div className="row">
        <div className="col">
            <InfoBox title="InfoBox" id="boxid"><LoremShort></LoremShort></InfoBox>
            <BlueInfoBox title="BlueInfoBox"><LoremShort></LoremShort></BlueInfoBox>
            <NoteBox title="NoteBox" id="notebox"><LoremShort></LoremShort></NoteBox>
        </div>
        <div className="col">
            <WarnBox title="WarnBox"><LoremShort></LoremShort></WarnBox>
            <BulbBox title="BulbBox"><LoremShort></LoremShort></BulbBox>
            <QaBox 
            q="A question or sentence." 
            a="An answer or sentence"/> 
        </div>
      </div>
      <h2>Headings</h2>
      <div className="row">
        <div className="col">
        <H1 text="H1" id="text" /> 
        <H2 text="H2" id="text" />
        <H3 text="H3" id="text" />
        </div>
        <div className="col">
        <Hsmoke text="Hsmoke" id="text" /> 
        <Hhopp text="Hhopp" id="text" /> 
        <Hhighlight> Highlight</Hhighlight>              
        <Hspoiler>  Hspoiler </Hspoiler>
        <Hwave text="Hwave" id="text" /> 
        <a href="#" className="underline--magical">PreCyse</a>
        </div>
      </div>
      <h2>Buttons</h2>
      <div className="row">
        <div className="col">
            <div className="col">
              <ButtonOne text="The Public" open="pubs" openclass="subcycletab"></ButtonOne>
            </div>
        </div>
        <div className="col">
            <BFHMoreButton it="id of part to be opened" />
        </div>
        <div className="col">
        <button className="tablinks Patient hp-more-button" > Something </button>
 
        </div>
      </div>
      <h2>Graphs</h2>
      <div className="row">
        <div className="col">
            <PieChart></PieChart>
            <DoughnutChart></DoughnutChart>
        </div>
        <div className="col">
            <BarChartTwoSets></BarChartTwoSets>
            <BarChart></BarChart>
        </div>
        <div className="col">
            <BarChartVertical></BarChartVertical>
            <PolarChart></PolarChart>
        </div>
      </div>
      <h2>Boxes</h2>
      <div className="row">
        <div className="col">
            
        </div>
        <div className="col">
            
        </div>
      </div>

        <div className="col">
             <h3 className="example">Exercises</h3>
            <i><h6>By Your name</h6></i>
            <div className="example-exercise">
                <p> All components should be in this file. The extra css has to be put into exapmle.css. Turn to Liliana if you need or want a scss file, too.</p>
                <p>The code you create should be in the respective columns where the assignments are, if not stated otherwise. </p>
                <p>Write down how you did it in the documentation-box as a documentation for the others. Use the Docu-Boc component for that.You have to add it to your axercise block manually. </p>
            </div>
            <DocuBox>
                <p>I wrote a text.</p>
            </DocuBox>
        </div>
        <hr/>
        <div className="col">
        <div className="row align-items-center">
                <div className="col"><h4>Lists</h4></div>
                <div className="col-1"> <div className="example-easy-tag">Easy</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
                <p>a. Create a numbered list of fruits. Five items are enough. Use the HTML list element.</p> 
                <p>b. Create a second column next to the one with the fruit list that contains a button. </p>
            </div>
        </div>
        <hr/>
        <div className="col">
        <div className="row align-items-center">
                <div className="col"><h4>Picture</h4></div>
                <div className="col-1"><div className="example-easy-tag">Easy</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
                <p>a. Insert a centered picture of Sinan here. It should be half as wide as the column and have a dottet frame in our purple.</p>
                <p>b. When hovering over the picture, it should turn black and white. </p>
            </div>
        </div>
        <hr/>
        <div className="col">
        <div className="row align-items-center">
                <div className="col"><h4>Picture Slider</h4></div>
                <div className="col-1"><div className="example-easy-tag">Easy</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise"></div>
            <p> Add a dummy sponsor to this slider.</p>
            <SimpleSlider>
            <a className="sponsor-container" href="https://bts-ev.de/">
              <img className="img-sponsor" src="https://static.igem.wiki/teams/5247/sponsors/bts.png"/>
            </a> 
            <a className="sponsor-container" href="https://www.uni-bielefeld.de/fakultaeten/technische-fakultaet/arbeitsgruppen/multiscale-bioengineering/campusbrauerei/">
              <img className="img-sponsor" src="https://static.igem.wiki/teams/5247/sponsors/campus-brauerei-hinterlegt.jpeg"/>
            </a>
            <a className="sponsor-container" href="www.idtdna.com">
              <img className="img-sponsor" src="https://static.igem.wiki/teams/5247/sponsors/idt-logo.png"></img>
            </a>
            <a className="sponsor-container" href="https://www.cebitec.uni-bielefeld.de/">
                  <img className="img-sponsor" src="https://static.igem.wiki/teams/5247/sponsors/cebitec-farbe.png"/>
            </a>
          </SimpleSlider>
        </div>
        <hr/>
        <div className="col">
        <div className="row align-items-center">
                <div className="col"><h4>Exercise box</h4></div>
                <div className="col-1"><div className="example-medium-tag">Medium</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
                <p>Create a box that differs in looks from the rest of the site and emphazises it contains an assignment. </p>
                <p>Archieve this effect by using background, shadow, border and/or other css effects on the class "example-exercise". The box should be aestetically pleasing unlike the documentation box. </p>
            </div>
        </div>
        <hr/>
        <div className="col">
        <div className="row align-items-center">
                <div className="col"><h4>PDF</h4></div>
                <div className="col-1"><div className="example-medium-tag">Medium</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise"></div>
            <p>a. Insert a pdf using our PDF component.</p>
        </div>
        <hr/>
        <div className="col exercise">
            <div className="row align-items-center">
                <div className="col"><h4> Smartphone compatibility</h4></div>
                <div className="col-1 "><div className="example-medium-tag">Medium</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
            <p> Create a simple box that has a different background color when the website is used on a smartphone (screen width 768px or smaller).  </p>
            <p> Use @media rules for that.</p>
            </div>
        </div>
        <hr/> 
        <div className="col exercise">
            <div className="row align-items-center">
                <div className="col"><h4>Collapsible</h4></div>
                <div className="col-1 "><div className="example-medium-tag">Medium</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
            <p> a. Use our Collapsible component to create a collapsible.</p>
            <p> b. The collapsible should contain three circles with a few words in a row (our Circle component) </p>
            </div>
        </div>
        <hr/> 
        <div className="col">
            <div className="row align-items-center">
                <div className="col"><h4>Header</h4></div>
                <div className="col-1"><div className="example-advanced-tag">Advanced</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
            <p>a. Create a header file for this page. It has to be visible and therefore be added to pages.ts</p>
            <p>b. Add this page to the navbar under "Contrubution". </p>
            </div>
        </div>
        <hr/>
        <div className="col exercise">
            <div className="row align-items-center">
                <div className="col"><h4>Chart with Victory</h4></div>
                <div className="col-1 "><div className="example-advanced-tag">Advanced</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
            <p>Create a simple bar Chart with React-Charts, using their <a href="https://mui.com/x/react-charts/"> documentation</a>  and dummy data of your choice. </p>
            </div>
        </div>
        <hr/>
        <div className="col exercise">
            <div className="row align-items-center">
                <div className="col"><h4> Simple React Component</h4></div>
                <div className="col-1 "><div className="example-advanced-tag">Advanced</div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
            <p> Create a react component that takes HTML, a link to a picture, a number and a word as input and return the code in a box with the word as a header. The picture and other code should be in two columns next to each other, under the header. The number should be multiplied by 2 and then shown somewhere with the other parts.</p>
            <p> See DocuBox component.  </p>
            </div>
        </div>
        <hr/>  
      <div className="col exercise">
            <div className="row align-items-center">
                <div className="col"><h4> </h4></div>
                <div className="col-1 "><div className="example-easy-tag"></div></div>
            </div>
            <i><h6>By </h6></i>
            <div className="example-exercise">
            <p> </p>
            </div>
        </div>
        <hr/> 

        


      </>
    );
  }


  export function DocuBox({children}: {children: React.ReactNode}){
    return(
        <>
            <div className="example-docu">
            <h5>Documentation: </h5>
            <div>
                {children}
            </div>
            </div>
        </>
    )
  }
  

  const BarChartTwoSets: React.FC = () => {
    const labels = ['January', 'February', 'March', 'April', 'May', 'June', 'July'];

    const data = {
        labels,
        datasets: [
          {
            label: 'Dataset 1',
            data: [
                0.004858000000000001,
                0.0008859999999999997,
                0.7264179999999972,
                0.2384159999999995,
                0.003703,
                0.2384159999999995,
                0.003703
              ],
            backgroundColor: 'rgba(255, 99, 132, 0.5)',
          },
          {
            label: 'Dataset 2',
            data: [
                0.004858000000000001,
                0.0008859999999999997,
                0.7264179999999972,
                0.2384159999999995,
                0.003703,
                0.2384159999999995,
                0.003703
              ],
            backgroundColor: 'rgba(53, 162, 235, 0.5)',
          },
        ],
      };
    const options = {
        responsive: true,
        plugins: {
          legend: {
            position: 'top' as const,
          },
          title: {
            display: true,
            text: 'BarChartTwoSets',
          },
        },
      };
  
    return (
      <div className="bar-chart-container">
        <Bar options={options} data={data} />
        </div>
    );
  };

  const BarChart: React.FC = () => {
    const labels = ['January', 'February', 'March', 'April', 'May', 'June', 'July'];

    const data = {
        labels,
        datasets: [
          {
            label: 'Dataset 1',
            data: [
                0.004858000000000001,
                0.0008859999999999997,
                0.7264179999999972,
                0.2384159999999995,
                0.003703,
                0.2384159999999995,
                0.003703
              ],
            backgroundColor: 'rgba(255, 99, 132, 0.5)',
          },
        ],
      };
    const options = {
        responsive: true,
        plugins: {
          legend: {
            position: 'top' as const,
          },
          title: {
            display: true,
            text: 'BarChartOneSet',
          },
        },
      };
  
    return (
      <div className="bar-chart-container">
        <Bar options={options} data={data} />
        </div>
    );
  };

  const BarChartVertical: React.FC = () => {
    const labels = ['January', 'February', 'March', 'April', 'May', 'June', 'July'];

    const data = {
        labels,
        datasets: [{
            axis: 'y',
            label: 'My First Dataset',
            data: [65, 59, 80, 81, 56, 55, 40],
            fill: false,
            backgroundColor: [
              'rgba(255, 99, 132, 0.2)',
              'rgba(255, 159, 64, 0.2)',
              'rgba(255, 205, 86, 0.2)',
              'rgba(75, 192, 192, 0.2)',
              'rgba(54, 162, 235, 0.2)',
              'rgba(153, 102, 255, 0.2)',
              'rgba(201, 203, 207, 0.2)'
            ],
            borderColor: [
                'rgb(255, 99, 132)',
                'rgb(255, 159, 64)',
                'rgb(255, 205, 86)',
                'rgb(75, 192, 192)',
                'rgb(54, 162, 235)',
                'rgb(153, 102, 255)',
                'rgb(201, 203, 207)'
              ],
              borderWidth: 1
            }
        ],
      };
    const options = {
        indexAxis: 'y' as const,
        responsive: true,
        plugins: {
          legend: {
            position: 'top' as const,
          },
          title: {
            display: true,
            text: 'Vertical Bar Chart',
          },
        },
      };
  
    return (
      <div className="bar-chart-container">
        <Bar options={options} data={data} />
        </div>
    );
  };


  const DoughnutChart: React.FC = () => {

    const data = {
        labels: ['Red', 'Blue', 'Yellow', 'Green', 'Purple', 'Orange'],
  datasets: [
    {
      label: '# of Votes',
      data: [12, 19, 3, 5, 2, 3],
      backgroundColor: [
        'rgba(255, 99, 132, 0.2)',
        'rgba(54, 162, 235, 0.2)',
        'rgba(255, 206, 86, 0.2)',
        'rgba(75, 192, 192, 0.2)',
        'rgba(153, 102, 255, 0.2)',
        'rgba(255, 159, 64, 0.2)',
      ],
      borderColor: [
        'rgba(255, 99, 132, 1)',
        'rgba(54, 162, 235, 1)',
        'rgba(255, 206, 86, 1)',
        'rgba(75, 192, 192, 1)',
        'rgba(153, 102, 255, 1)',
        'rgba(255, 159, 64, 1)',
      ],
      borderWidth: 1,
    },
  ],
    };
    return (
      <div className="bar-chart-container">
        <Doughnut data={data} />
        </div>
    );
  };


  const PolarChart: React.FC = () => {
    const data = {
        labels: ['Red', 'Blue', 'Yellow', 'Green', 'Purple', 'Orange'],
        datasets: [
          {
            label: '# of Votes',
            data: [12, 19, 3, 5, 2, 3],
            backgroundColor: [
              'rgba(255, 99, 132, 0.5)',
              'rgba(54, 162, 235, 0.5)',
              'rgba(255, 206, 86, 0.5)',
              'rgba(75, 192, 192, 0.5)',
              'rgba(153, 102, 255, 0.5)',
              'rgba(255, 159, 64, 0.5)',
            ],
            borderWidth: 1,
          },
        ],
      };


    return (
        <div className="bar-chart-container">
          <PolarArea data={data} />;
          </div>
      );
    };